unit CarsClassU;

interface

type
  //These are objects, hence inheriting from TObject
  TCar = class(TObject)
  private
    FSpeed: Integer;
  protected
    //Property writer routine
    procedure SetSpeed(Value: Integer); virtual;
  public
    //Custom constructor that takes a default speed parameter
    constructor Create(ASpeed: Integer);
    destructor Destroy; override;
    procedure Drive; virtual;
    //Property definition
    property Speed: Integer read FSpeed write SetSpeed;
  end; //TCar

  TRobin = class(TCar)
  protected
    procedure SetSpeed(Value: Integer); override;
  end; //TRobin

  TPorsche = class(TCar)
  protected
    procedure SetSpeed(Value: Integer); override;
  public
    procedure Drive; override;
  end; //TPorsche


implementation

uses
  Dialogs;

{ TCar }

constructor TCar.Create(ASpeed: Integer);
begin
  inherited Create;
  //Take default peed and set the appropriate property
  Speed := ASpeed
end;

destructor TCar.Destroy;
begin
  //Any important tidy-up stuff
  inherited
end;

procedure TCar.Drive;
begin
  ShowMessage('I like driving in my car...')
end;

procedure TCar.SetSpeed(Value: Integer);
begin
  FSpeed := Value;
end;

{ TRobin }

//Validate assigned speed and then pass it back to TCar.SetSpeed
procedure TRobin.SetSpeed(Value: Integer);
begin
  if Value > 35 then
    Value := 35;
  inherited {SetSpeed(Value)}
end;

{ TPorsche }

//Porsche has different driving capabilities
procedure TPorsche.Drive;
begin
  ShowMessage('Vroom, roar, etc.')
end;

//Validate assigned speed and then pass it back to TCar.SetSpeed
procedure TPorsche.SetSpeed(Value: Integer);
begin
  if Value > 135 then
    Value := 135;
  inherited
end;

end.
